use eframe::egui::{Response, TextEdit, Ui, Vec2, Widget};

use super::state::AppState;

pub struct PromptInput<'a> {
    app_state: &'a mut AppState,
}

impl<'a> PromptInput<'a> {
    pub fn new(app_state: &'a mut AppState) -> Self {
        Self { app_state }
    }
}

impl<'a> Widget for PromptInput<'a> {
    fn ui(self, ui: &mut Ui) -> Response {
        ui.vertical(|ui| {
            let label = ui.heading("Prompt");
            ui.add_sized(
                Vec2::new(ui.available_width() / 2.0, 100.0),
                TextEdit::multiline(&mut self.app_state.prompt_input),
            )
            .labelled_by(label.id);

            ui.horizontal(|ui| {
                if ui.button("Submit").clicked() {
                    self.app_state.handle_submission();
                }

                if ui.button("Clear").clicked() {
                    self.app_state.prompt_input.clear();
                }
            })
        }).response
    }
}
